# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class EVENTUSERAUTHENTICATED(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, id: int=None, username: str='username', main_role: str=None, grants: List[str]=None, authentication_date: datetime=None):  # noqa: E501
        """EVENTUSERAUTHENTICATED - a model defined in Swagger

        :param id: The id of this EVENTUSERAUTHENTICATED.  # noqa: E501
        :type id: int
        :param username: The username of this EVENTUSERAUTHENTICATED.  # noqa: E501
        :type username: str
        :param main_role: The main_role of this EVENTUSERAUTHENTICATED.  # noqa: E501
        :type main_role: str
        :param grants: The grants of this EVENTUSERAUTHENTICATED.  # noqa: E501
        :type grants: List[str]
        :param authentication_date: The authentication_date of this EVENTUSERAUTHENTICATED.  # noqa: E501
        :type authentication_date: datetime
        """
        self.swagger_types = {
            'id': int,
            'username': str,
            'main_role': str,
            'grants': List[str],
            'authentication_date': datetime
        }

        self.attribute_map = {
            'id': 'id',
            'username': 'username',
            'main_role': 'main_role',
            'grants': 'grants',
            'authentication_date': 'authentication_date'
        }
        self._id = id
        self._username = username
        self._main_role = main_role
        self._grants = grants
        self._authentication_date = authentication_date

    @classmethod
    def from_dict(cls, dikt) -> 'EVENTUSERAUTHENTICATED':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The EVENT_USER_AUTHENTICATED of this EVENTUSERAUTHENTICATED.  # noqa: E501
        :rtype: EVENTUSERAUTHENTICATED
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> int:
        """Gets the id of this EVENTUSERAUTHENTICATED.


        :return: The id of this EVENTUSERAUTHENTICATED.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this EVENTUSERAUTHENTICATED.


        :param id: The id of this EVENTUSERAUTHENTICATED.
        :type id: int
        """

        self._id = id

    @property
    def username(self) -> str:
        """Gets the username of this EVENTUSERAUTHENTICATED.

        The user name for login  # noqa: E501

        :return: The username of this EVENTUSERAUTHENTICATED.
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username: str):
        """Sets the username of this EVENTUSERAUTHENTICATED.

        The user name for login  # noqa: E501

        :param username: The username of this EVENTUSERAUTHENTICATED.
        :type username: str
        """

        self._username = username

    @property
    def main_role(self) -> str:
        """Gets the main_role of this EVENTUSERAUTHENTICATED.

        Which is the main role of the user  # noqa: E501

        :return: The main_role of this EVENTUSERAUTHENTICATED.
        :rtype: str
        """
        return self._main_role

    @main_role.setter
    def main_role(self, main_role: str):
        """Sets the main_role of this EVENTUSERAUTHENTICATED.

        Which is the main role of the user  # noqa: E501

        :param main_role: The main_role of this EVENTUSERAUTHENTICATED.
        :type main_role: str
        """
        allowed_values = ["admin", "user", "guest"]  # noqa: E501
        if main_role not in allowed_values:
            raise ValueError(
                "Invalid value for `main_role` ({0}), must be one of {1}"
                .format(main_role, allowed_values)
            )

        self._main_role = main_role

    @property
    def grants(self) -> List[str]:
        """Gets the grants of this EVENTUSERAUTHENTICATED.


        :return: The grants of this EVENTUSERAUTHENTICATED.
        :rtype: List[str]
        """
        return self._grants

    @grants.setter
    def grants(self, grants: List[str]):
        """Sets the grants of this EVENTUSERAUTHENTICATED.


        :param grants: The grants of this EVENTUSERAUTHENTICATED.
        :type grants: List[str]
        """
        allowed_values = ["GRANT_WAN_READ", "GRANT_LAN_READ", "GRANT_CONFIGURATION_READ", "GRANT_CONFIGURATION_WRITE", "GRANT_BASIC_CHANGER_DATA_READ", "GRANT_TELEMETRY_READ", "GRANT_TRANSACTION_LOG_READ", "GRANT_TRANSACTION_LOG_WRITE"]  # noqa: E501
        if not set(grants).issubset(set(allowed_values)):
            raise ValueError(
                "Invalid values for `grants` [{0}], must be a subset of [{1}]"  # noqa: E501
                .format(", ".join(map(str, set(grants) - set(allowed_values))),  # noqa: E501
                        ", ".join(map(str, allowed_values)))
            )

        self._grants = grants

    @property
    def authentication_date(self) -> datetime:
        """Gets the authentication_date of this EVENTUSERAUTHENTICATED.

        when have been validated  # noqa: E501

        :return: The authentication_date of this EVENTUSERAUTHENTICATED.
        :rtype: datetime
        """
        return self._authentication_date

    @authentication_date.setter
    def authentication_date(self, authentication_date: datetime):
        """Sets the authentication_date of this EVENTUSERAUTHENTICATED.

        when have been validated  # noqa: E501

        :param authentication_date: The authentication_date of this EVENTUSERAUTHENTICATED.
        :type authentication_date: datetime
        """

        self._authentication_date = authentication_date
